Summary: Utility for flashing LEGO Mindstorms NXT firmware
Name: libnxt
Version: 0.3
Release: 11%{?dist}
License: GPLv2+
Group: Development/Tools
URL: http://code.google.com/p/libnxt/
Source0: http://libnxt.googlecode.com/files/%{name}-%{version}.tar.gz
# Short document describing how to reflash the NXT firmware
Source1: %{name}-NXT-REFLASH-HOWTO
# Use appropriate tool's names (as per arm-gp2x-linux-gcc package)
Patch0: %{name}-flash-write-makefile.patch
# Use the hashlib module instead of the deprecated sha module
Patch1: %{name}-hashlib.patch
# Removes the following compilation warning and make the code
# endian-independent:
# samba.c: In function 'nxt_read_common':
# samba.c:90: warning: dereferencing type-punned pointer will break
# strict-aliasing rules
Patch2: %{name}-samba-endian-independent.patch
# Respect CFLAGS and LDFLAGS environment variables during the build
Patch3: %{name}-sconstruct-optflags.patch
# Upstream issue: http://code.google.com/p/libnxt/issues/detail?id=2
Patch4: %{name}-detach-driver.patch

BuildRequires: libusb-devel
BuildRequires: scons
BuildRequires: arm-none-eabi-gcc-cs


%description
LibNXT is an utility library for talking to the LEGO Mindstorms NXT.
 It currently does:
 * Handling USB communication and locating the NXT in the USB tree.
 * Interaction with the Atmel AT91SAM boot assistant.
 * Flashing of a firmware image to the NXT.
 * Execution of code directly in RAM.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
cp -p %{SOURCE1} NXT-REFLASH-HOWTO
make -C flash_write clean # to be sure that we will regenerate the flash.bin


%build
make -C flash_write
export CFLAGS="%{optflags}"
export LDFLAGS="%{optflags}"
scons %{?_smp_mflags}


%install
install -p -D -m 755 fwexec %{buildroot}%{_bindir}/nxt-fwexec
install -p -D -m 755 fwflash %{buildroot}%{_bindir}/nxt-fwflash


%files
%doc COPYING README NXT-REFLASH-HOWTO
%{_bindir}/nxt-fwexec
%{_bindir}/nxt-fwflash


%changelog
* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Aug 05 2013 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.3-8
- switch to use arm-none-eabi-gcc-cs toolkit, fixes rhbz#992103,
- add patch to detach kernel driver,
- specfile cleanup.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Sep 13 2010 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.3-2
- Fix for respecting CFLAGS and LDFLAGS during the build,
- Fix for strict-aliasing rules problem,
- Describe purpose of the patches,
- Firmware reflash HOWTO added.

* Mon Jul 19 2010 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.3-1
- Initial RPM release
